format PE64 GUI 5.0 at 140000000h
entry main

include "win64a.inc"

WINDOW_HEIGHT       equ 34
TIMER_ID            equ 7
COLOR_              equ 0C000AF70h
X_scale             equ 30.0
Y_scale             equ 27.0

macro gcall prg* {
  common
    call    prg
    if defined checkgp
        test    eax, eax
        jnz     .error_handler
    end if
}
macro bcall prg* {
  common
    call    prg
    if defined checkgp
        test    eax, eax
        jz     .error_handler
    end if
}

;    checkgp             equ 1
; --------------------
hWnd        equ 40
dpFrame$    equ 88

align 8
dlg_proc:

    push    rbx
    push    rbp
    push    rsi
    push    rdi
    add     rsp, -dpFrame$

    lea     rdi, [rsp+32]
    mov     [rdi+hWnd],rcx

    cmp     dx, WM_TIMER
    jne     .next1
.timer:
    call    draw_dig

    lea     rax, [rsi+24]
    xor     edx, edx
    xor     r8d, r8d
    movups  xmm0,[rax]
    movups  xmm1,[rax+16]
    lea     r9,  [rax+40]
    movaps  [rdi],xmm0
    movaps  [rdi+16],xmm1
    mov     qword [rdi+32],ULW_ALPHA
    mov     rcx, [rdi+hWnd]
    bcall   [UpdateLayeredWindow]

align 8
.dpret:
    xor     eax, eax
    add     rsp, dpFrame$
    pop     rdi
    pop     rsi
    pop     rbp
    pop     rbx
    ret
.next1:
    cmp     dx, WM_LBUTTONDOWN
    jne     .next2
.lbuttondown:
    mov     edx, WM_NCLBUTTONDOWN
    mov     r8d, 2
    xor     r9d, r9d
    call    [SendMessageA]
    jmp     .dpret
.next2:
    cmp     dx, WM_LBUTTONDBLCLK
    je      .error_handler
    cmp     dx, WM_INITDIALOG
    je      initdialog
    cmp     dx, WM_CLOSE
    jne     .dpret
.error_handler:
if defined checkgp
    mov     rcx, [rdi+hWnd]
end if
    xor     edx, edx
    call    [EndDialog]
    jmp     .dpret
; --------------------
ddFrame$    equ 144
align 8
draw_dig:
    push    rdi
    movaps  [rsp-16],xmm6
    add     rsp, - ddFrame$

    lea     rsi, [hGraphics]
    lea     rbp, [rsp+40]
    lea     rdx, [rsi + Matrix0 - hGraphics]
    and     qword [rdx + 32],0
    mov     rcx, [rsi]
    call    [GdipSetWorldTransform]

    lea     rcx, [rbp+32]
    call    [GetLocalTime]
    lea     rax, [rsi + k0_2  - hGraphics]
    movddup xmm0,qword [rax]
    movddup xmm6,qword [rax + k0_7  - k0_2]
    mov     rbx, qword [rax + k2_65 - k0_2]
    movaps  [rbp-8],xmm0
    mov     byte [rbp+8],1

    mov     dx, [rbp+44]
    cmp     word [rax + second - k0_2],dx
    mov     word [rax + second - k0_2],dx
    jne     .grclear
    xor     edi, edi
    shr     rbx, 32
    jmp     .drawel

.grclear:
    mov     edx, 1000000h
    mov     rcx, [rsi]
    gcall   [GdipGraphicsClear]

    mov     byte [rbp+8],2
    mov     [rbp+16],rax
    lea     rdx, [rbp+40]
    lea     rdi, [segments]
    mov     [rbp+24],rdx

.loopfills:
    mov     cl, 10
    mov     al, 2
    xadd    [rbp+24], rax
    mov     ax, [rax]
    div     cl
    movzx   edx, al
    movzx   eax, ah
    mov     dl, [rdi+rdx]
    mov     al, [rdi+rax]
    shl     eax, 7
    or      eax, edx
    or      [rbp+16],rax
    ror     qword [rbp+16],14
    cmp     byte [rbp+8],0
    je      .setpdr
.drawel:
    mov     rcx, [rsi]
    mov     rdx, [rsi+8]
    movd    xmm2,ebx
    movss   xmm3,xmm6
    gcall   [GdipFillEllipse]
    psrldq  xmm6,4
    dec     byte [rbp+8]
    js      .error_handler
    test    edi, edi
    jz      .drawel
    jmp     .loopfills

.setpdr:
    shr     qword [rbp+16], 22
    lea     rbx, [Matrix0]
    mov     eax, 6
    mov     [rbp],rax
    lea     rdi, [rbp+24]
    lea     ecx, [eax+3]
    movlps  xmm6, qword [rbx - Matrix0 + scale]
    add     rsi, -72
    rep     movsq
    add     rdi, -72
    jmp    .shift
align 16
.loopfilln:
    movlps  xmm0,[rdi]
    mulps   xmm0, xmm6
    movlps  qword [rbx + 32],xmm0
    mov     rcx, [rsi]
    mov     rdx, rbx
    gcall   [GdipSetWorldTransform]

    mov     rcx,[rsi]
    mov     rdx,[rsi+8]
    lea     r8, [spoints]
    mov     r9d, 6
    gcall   [GdipFillPolygon2]

align 8
.decCnt:
    add     rdi, 8
    dec     byte [rbp]
    js      .nextNumber
    lea     rdx, [rbx+40]
    cmp     byte [rbp],3
    cmove   rbx, rdx
.shift:
    shr     qword [rbp+16],1
    jc      .loopfilln
    jmp     .decCnt
.nextNumber:
    cmp     [rbp+16],rax
    je      .error_handler
    mov     byte [rbp],6
    lea     rbx, [Matrix0]
    ror     qword [rdi+8],32
    movss   xmm1, [rdi+8]
    mov     ecx, 4
    add     rdi, -56
.loopadd:
    movddup xmm0,xmm1
    addps   xmm0,[rdi+rax]
    movaps  [rdi+rax],xmm0
    add     al, 16
    loop    .loopadd
    jmp     .shift
.error_handler:
    add     rsp, ddFrame$
    movaps  xmm6,[rsp-16]
    pop     rdi
    ret
; --------------------
mFrame$     equ 88
hGdipToken  equ 40

main:
    add     rsp, -mFrame$
    lea     rcx, [rsp+hGdipToken]
    lea     rdx, [rcx+8]
    mov     dword [rdx], 1
    movups  [rdx+8], xmm0
    xor     r8d, r8d
    gcall   [GdiplusStartup]
    lea     rdx, [dlg_template]
    xor     ecx, ecx
    lea     r9,  [dlg_proc]
    xor     r8d, r8d
    call    [DialogBoxIndirectParamA]
.error_handler:
    mov     rcx, [hBrush]
    test    ecx, ecx
    jz      .clk0001
    call    [GdipDeleteBrush]
.clk0001:
    mov     rcx, [hGraphics]
    test    ecx, ecx
    jz      .clk0002
    call    [GdipDeleteGraphics]
.clk0002:
    mov     rcx, [rsp+hGdipToken]
    test    ecx, ecx
    jz      .clk0003
    call    [GdiplusShutdown]
.clk0003:
    mov     rcx, [hDC]
    test    ecx, ecx
    jz      .clkexit
    mov     rdx, [hOldBmp]
    call    [SelectObject]
    mov     rcx, rax
    call    [DeleteObject]
    mov     rcx, [hDC]
    call    [DeleteDC]
.clkexit:
    xor     ecx, ecx
    add     rsp, mFrame$
    jmp     [ExitProcess]
; --------------------
align 8
initdialog:
    lea     rdx, [rcWindow]
    mov     rbp, rdx
    bcall   [GetClientRect]
    xor     ecx, ecx
    call    [GetDC]

if defined checkgp
    test    eax, eax
    jz      dlg_proc.error_handler
end if

    mov     rcx, rax
    mov     rsi, rax
    call    [CreateCompatibleDC]

if defined checkgp
    test    eax, eax
    jnz     .mkbmp
.release_dc_and_destroy:
    mov     rcx, rsi
    xor     edx, edx
    call    [ReleaseDC]
    jmp     dlg_proc.error_handler
.mkbmp:
end if

    mov     [hDC], rax
    mov     rbx, rax
    mov     rcx, rsi
    mov     edx, [rbp+RECT.right]
    mov     r8d, [rbp+RECT.bottom]
    call    [CreateCompatibleBitmap]

if defined checkgp
    test    eax, eax
    jz      .release_dc_and_destroy
end if

    mov     rdx, rax
    mov     rcx, rbx
    call    [SelectObject]
    mov     [rbp - (rcWindow -hOldBmp)],rax
    mov     rcx,rsi
    xor     edx, edx
    call    [ReleaseDC]
    mov     rcx, rbx
    lea     rdx, [hGraphics]
    mov     rsi, rdx
    gcall   [GdipCreateFromHDC]
    mov     rcx,[rsi]
    mov     edx, 4
    gcall   [GdipSetSmoothingMode]
    xor     ecx, ecx
    lea     rdx, [rsi+8]
    gcall   [GdipCreateSolidFill]

    mov     edx, COLOR_
    mov     rcx, [rsi+8]
    gcall   [GdipSetSolidFillColor]

    mov     rcx, [rdi+hWnd]
    or      rdx, -1
    xor     r8d, r8d
    xor     r9d, r9d
    movaps  [rdi],xmm0
    mov     dword [rdi+16], SWP_NOMOVE or SWP_NOSIZE or SWP_NOREDRAW or SWP_NOSENDCHANGING
    bcall   [SetWindowPos]

    mov     rcx, [rdi+hWnd]
    mov     edx, TIMER_ID
    mov     r8d, 500
    xor     r9d, r9d
    call   [SetTimer]
    jmp     dlg_proc.timer
if defined checkgp
.error_handler:
    jmp     dlg_proc.error_handler
end if
; --------------------
align 8
segments:
            db 7Bh,60h,37h, 67h, 6Ch, 4Fh, 5Fh, 62h, 7Fh, 6Fh
align 8
spoints:    dd 0.1, 0.1, 0.2, 0.0, 0.8, 0.0, 0.9, 0.1, 0.8, 0.2, 0.2, 0.2
spos:       dd  0.1,2.0, 0.1,0.0, 0.1,1.0, 0.2,0.1, 0.2,1.1, 1.2,0.1, 1.2,1.1
            dd 0,0, 1.7,1.3
hGraphics   dq 0
hBrush      dq 0
hOldBmp     dq 0
hDC         dq 0
tPT         dq PTs
PTs         dq 0
dwBF        dq BF
rcWindow  RECT 0,0,0,0
scale       dd X_scale,Y_scale
align 16
Matrix0     dd 1.0
            dd 0
            dd 1952533809
            dd -1
            dd X_scale
            dd 0
            dd 0
            dd Y_scale
            dd 0
            dd 0
Matrix90    dd 1.0
            dd 0
            dd 1952533809
            dd -1
            dd 0
            dd Y_scale
            dd -X_scale
            dd 0
            dd 0
            dd 0
BF          dd 1FF0000h
align 8
k0_2        dd 0.2
            dd 0
k0_7        dd 0.7
k1_3        dd 1.3
k2_65       dd 2.65
k5_65       dd 5.65
second      dw 0

align 4
dlg_template:
    dd DS_CENTER or WS_POPUP, WS_EX_LAYERED
    dw 0,0,0, WINDOW_HEIGHT * 385 / 100, WINDOW_HEIGHT, 0,0
    du 'SClock',0
; --------------------

  data import

library kernel32, 'kernel32', \
        gdi32, 'gdi32', \
        user32, 'user32', \
        gdiplus, 'gdiplus'

import kernel32, \
       GetLocalTime, 'GetLocalTime', \
       ExitProcess, 'ExitProcess'

import gdi32, \
       CreateCompatibleBitmap, 'CreateCompatibleBitmap', \
       CreateCompatibleDC, 'CreateCompatibleDC', \
       SelectObject, 'SelectObject', \
       DeleteObject, 'DeleteObject', \
       DeleteDC, 'DeleteDC'

import user32, \
       DialogBoxIndirectParamA, 'DialogBoxIndirectParamA', \
       EndDialog, 'EndDialog', \
       GetClientRect, 'GetClientRect', \
       SetTimer, 'SetTimer', \
       UpdateLayeredWindow, 'UpdateLayeredWindow', \
       GetDC, 'GetDC', \
       ReleaseDC, 'ReleaseDC', \
       SendMessageA, 'SendMessageA', \
       SetWindowPos, 'SetWindowPos'

import gdiplus, \
       GdiplusStartup, 'GdiplusStartup', \
       GdiplusShutdown, 'GdiplusShutdown', \
       GdipSetSmoothingMode, 'GdipSetSmoothingMode', \
       GdipCreateFromHDC, 'GdipCreateFromHDC', \
       GdipGraphicsClear, 'GdipGraphicsClear', \
       GdipCreateSolidFill, 'GdipCreateSolidFill', \
       GdipSetSolidFillColor, 'GdipSetSolidFillColor', \
       GdipFillEllipse, 'GdipFillEllipse', \
       GdipSetWorldTransform, 'GdipSetWorldTransform', \
       GdipFillPolygon2, 'GdipFillPolygon2', \
       GdipDeleteBrush, 'GdipDeleteBrush', \
       GdipDeleteGraphics, 'GdipDeleteGraphics'
end data
